"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.range = exports.noop = exports.streamEnd = exports.sleep = void 0;
function sleep(n) {
    return __awaiter(this, void 0, void 0, function* () {
        return new Promise((res) => setTimeout(res, n));
    });
}
exports.sleep = sleep;
function streamEnd(stream) {
    return __awaiter(this, void 0, void 0, function* () {
        return new Promise((res, rej) => {
            stream.on('close', res);
            stream.on('error', rej);
        });
    });
}
exports.streamEnd = streamEnd;
function noop(...args) {
    return undefined;
}
exports.noop = noop;
function range(len, start = 0) {
    return [...new Array(len)].map(() => start++);
}
exports.range = range;
//# sourceMappingURL=helper-functions.js.map