"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __asyncValues = (this && this.__asyncValues) || function (o) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator], i;
    return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
    function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
    function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DEFAULT_ERROR_TEXT = exports.numberToStringAsync = exports.numberToString = exports.streamToArray = exports.filterOutOddsAsync = exports.filterOutOddsSync = exports.failOnEvensAsync = exports.failOnOddsAsync = exports.failOnEvensSync = exports.failOnOddsSync = exports.addAsync = exports.add = exports.delayerMult2 = exports.delayer = exports.getFailOnNumberAsyncFunctionMult2 = exports.getFailOnNumberAsyncFunction = exports.getFailOnNumberFunction = void 0;
const helper_functions_1 = require("./helper-functions");
function getFailOnNumberFunction(input, errorText = exports.DEFAULT_ERROR_TEXT) {
    return (num) => {
        if (num === input) {
            throw Error(errorText);
        }
        return num;
    };
}
exports.getFailOnNumberFunction = getFailOnNumberFunction;
function getFailOnNumberAsyncFunction(input, delay, errorText = exports.DEFAULT_ERROR_TEXT) {
    const syncVersion = getFailOnNumberFunction(input, errorText);
    return (num) => __awaiter(this, void 0, void 0, function* () {
        const newNum = syncVersion(num);
        if (delay) {
            yield (0, helper_functions_1.sleep)(delay);
        }
        return newNum;
    });
}
exports.getFailOnNumberAsyncFunction = getFailOnNumberAsyncFunction;
function getFailOnNumberAsyncFunctionMult2(input, delay, errorText = exports.DEFAULT_ERROR_TEXT) {
    const regularAsyncVersion = getFailOnNumberAsyncFunction(input, delay, errorText);
    return (num) => __awaiter(this, void 0, void 0, function* () { return (yield regularAsyncVersion(num)) * 2; });
}
exports.getFailOnNumberAsyncFunctionMult2 = getFailOnNumberAsyncFunctionMult2;
function delayer(delay) {
    return (num) => __awaiter(this, void 0, void 0, function* () {
        yield (0, helper_functions_1.sleep)(delay);
        return num;
    });
}
exports.delayer = delayer;
function delayerMult2(delay) {
    return (num) => __awaiter(this, void 0, void 0, function* () {
        yield (0, helper_functions_1.sleep)(delay);
        return num * 2;
    });
}
exports.delayerMult2 = delayerMult2;
function add(n) {
    return (chunk) => chunk + n;
}
exports.add = add;
function addAsync(n) {
    return (chunk) => __awaiter(this, void 0, void 0, function* () { return chunk + n; });
}
exports.addAsync = addAsync;
function failOnOddsSync(n) {
    if (n % 2 === 0) {
        throw Error(exports.DEFAULT_ERROR_TEXT);
    }
    return n;
}
exports.failOnOddsSync = failOnOddsSync;
function failOnEvensSync(n) {
    if (n % 2 === 1) {
        throw Error(exports.DEFAULT_ERROR_TEXT);
    }
    return n;
}
exports.failOnEvensSync = failOnEvensSync;
function failOnOddsAsync(n) {
    return __awaiter(this, void 0, void 0, function* () {
        return failOnOddsSync(n);
    });
}
exports.failOnOddsAsync = failOnOddsAsync;
function failOnEvensAsync(n) {
    return __awaiter(this, void 0, void 0, function* () {
        return !failOnOddsSync(n);
    });
}
exports.failOnEvensAsync = failOnEvensAsync;
function filterOutOddsSync(n) {
    return !(n % 2);
}
exports.filterOutOddsSync = filterOutOddsSync;
function filterOutOddsAsync(delay) {
    return (n) => __awaiter(this, void 0, void 0, function* () {
        if (delay) {
            yield (0, helper_functions_1.sleep)(delay);
        }
        return !(n % 2);
    });
}
exports.filterOutOddsAsync = filterOutOddsAsync;
function streamToArray(transform) {
    var _a, transform_1, transform_1_1;
    var _b, e_1, _c, _d;
    return __awaiter(this, void 0, void 0, function* () {
        const arr = [];
        try {
            for (_a = true, transform_1 = __asyncValues(transform); transform_1_1 = yield transform_1.next(), _b = transform_1_1.done, !_b;) {
                _d = transform_1_1.value;
                _a = false;
                try {
                    const chunk = _d;
                    arr.push(chunk);
                }
                finally {
                    _a = true;
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (!_a && !_b && (_c = transform_1.return)) yield _c.call(transform_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return arr;
    });
}
exports.streamToArray = streamToArray;
function numberToString(n) {
    return n.toString();
}
exports.numberToString = numberToString;
function numberToStringAsync(n) {
    return __awaiter(this, void 0, void 0, function* () {
        return numberToString(n);
    });
}
exports.numberToStringAsync = numberToStringAsync;
exports.DEFAULT_ERROR_TEXT = 'asdf';
//# sourceMappingURL=test-helper.js.map