"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.arrayJoinTransform = void 0;
const simple_transform_1 = require("../base/simple-transform");
function arrayJoinTransform(length, options) {
    let array = [];
    const transformer = (chunk) => {
        array.push(chunk);
        if (array.length >= length) {
            const tempArray = array;
            array = [];
            return tempArray;
        }
        else {
            return undefined;
        }
    };
    const optionsWithFlush = Object.assign(Object.assign({}, options), { flush: (callback) => {
            callback(null, array.length ? array : undefined);
        } });
    return new simple_transform_1.SimpleTransform(transformer, optionsWithFlush);
}
exports.arrayJoinTransform = arrayJoinTransform;
//# sourceMappingURL=array-join-transform.js.map