"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.asyncCounterTransform = exports.counterTransform = void 0;
const call_on_data_transforms_1 = require("./call-on-data-transforms");
function counterTransform(countFilter, options) {
    const shouldCounterBeIncreased = countFilter || (() => true);
    let count = 0;
    const counter = (chunk) => {
        count += shouldCounterBeIncreased(chunk) ? 1 : 0;
    };
    const transform = (0, call_on_data_transforms_1.callOnDataSyncTransform)(counter, options);
    const getCounter = () => count;
    return { transform, getCounter };
}
exports.counterTransform = counterTransform;
function asyncCounterTransform(countFilter, options) {
    const shouldCounterBeIncreased = countFilter;
    let count = 0;
    const counter = (chunk) => __awaiter(this, void 0, void 0, function* () {
        count += (yield shouldCounterBeIncreased(chunk)) ? 1 : 0;
    });
    const transform = (0, call_on_data_transforms_1.callOnDataAsyncTransform)(counter, options);
    const getCounter = () => count;
    return { transform, getCounter };
}
exports.asyncCounterTransform = asyncCounterTransform;
//# sourceMappingURL=counter-transform.js.map